package com.morphoss.acal.database.resourcesmanager;

/**
 * Represents the response to a CacheRequest. CacheRequests do not necessarily have to generate a response. See @CacheRequest for more info
 * 
 * @author Chris Noldus
 *
 * @param <E>
 */
public abstract class ResourceResponse<E> {

	/**
	 * Returns the response object generated by a CacheRequest.
	 * @return
	 */
	public abstract E result();
	
	protected ResourceResponse(Exception e) { this.error = e; }
	protected ResourceResponse() {}
	
	public boolean wasSuccessful() {
		return error==null;
	}
	
	public Exception getError() {
		return this.error;
	}
	protected Exception error = null;
}
